searchData={"content_type":"text/markdown","items":[{"doc":"A small abstraction to describe how to access files.\n\nIt works with different file systems, for local files\nand remote ones.\n\nIt's a library to parse and validate URIs, with the necessary\nattributes.\n\nSee the supported specifications for more details:\n\n* `FSS.Local`\n* `FSS.HTTP`\n* `FSS.S3`","ref":"FSS.html","title":"FSS","type":"module"},{"doc":"Can be used to refer to any entry that FSS supports.","ref":"FSS.html#t:entry/0","title":"FSS.entry/0","type":"type"},{"doc":"Specification for accessing HTTP(s) resources.","ref":"FSS.HTTP.html","title":"FSS.HTTP","type":"module"},{"doc":"Parses an HTTP or HTTPs url.","ref":"FSS.HTTP.html#parse/2","title":"FSS.HTTP.parse/2","type":"function"},{"doc":"* `:config` - A `Config.t()`. This is optional and by default it's `nil`.","ref":"FSS.HTTP.html#parse/2-options","title":"Options - FSS.HTTP.parse/2","type":"function"},{"doc":"Represents the configuration for an HTTP resource.","ref":"FSS.HTTP.Config.html","title":"FSS.HTTP.Config","type":"module"},{"doc":"Only `:headers` are configurable now.\n\nThey are a list of `{String.t(), String.t()}`","ref":"FSS.HTTP.Config.html#t:t/0","title":"FSS.HTTP.Config.t/0","type":"type"},{"doc":"Represents the actual HTTP resource.","ref":"FSS.HTTP.Entry.html","title":"FSS.HTTP.Entry","type":"module"},{"doc":"The entry type of an HTTP resource.\n\nThe `:url` is expected to be a valid HTTP or HTTPS URL,\nand `:config` is expected to be a `Config.t()`.","ref":"FSS.HTTP.Entry.html#t:t/0","title":"FSS.HTTP.Entry.t/0","type":"type"},{"doc":"Specification for local files.\n\nThe `FSS.Local.Entry` represents a local file with its path.","ref":"FSS.Local.html","title":"FSS.Local","type":"module"},{"doc":"Builds a `FSS.Local.Entry` struct from a path.","ref":"FSS.Local.html#from_path/1","title":"FSS.Local.from_path/1","type":"function"},{"doc":"iex> FSS.Local.from_path(\"/home/joe/file.txt\")\n    %FSS.Local.Entry{path: \"/home/joe/file.txt\"}\n\n    iex> FSS.Local.from_path(\"C:/joe/file.txt\")\n    %FSS.Local.Entry{path: \"C:/joe/file.txt\"}","ref":"FSS.Local.html#from_path/1-examples","title":"Examples - FSS.Local.from_path/1","type":"function"},{"doc":"Represents a local file.","ref":"FSS.Local.Entry.html","title":"FSS.Local.Entry","type":"module"},{"doc":"The only attribute is the `:path` to a local file.","ref":"FSS.Local.Entry.html#t:t/0","title":"FSS.Local.Entry.t/0","type":"type"},{"doc":"Specification for accessing AWS S3 resources.","ref":"FSS.S3.html","title":"FSS.S3","type":"module"},{"doc":"Builds a `Config.t()` reading from the system env.","ref":"FSS.S3.html#config_from_system_env/0","title":"FSS.S3.config_from_system_env/0","type":"function"},{"doc":"Parses a URL in the format `s3://bucket/resource-key`.","ref":"FSS.S3.html#parse/2","title":"FSS.S3.parse/2","type":"function"},{"doc":"* `:config` - It expects a `Config.t()` or a `Keyword.t()` with the keys\n    representing the attributes of the `Config.t()`. By default it is `nil`,\n    which means that we are going to try to fetch the credentials and configuration\n    from the system's environment variables.\n\n    The following env vars are read:\n\n    - `AWS_ACCESS_KEY_ID`\n    - `AWS_SECRET_ACCESS_KEY`\n    - `AWS_REGION` or `AWS_DEFAULT_REGION`\n    - `AWS_SESSION_TOKEN`\n\n    In case the endpoint is not provided, we compute a valid one for the AWS S3 API,\n    That is going to follow the path style. The endpoint is not going to include the\n    `:bucket` in it, being necessary to do that when using this FSS entry.\n\n    See https://docs.aws.amazon.com/AmazonS3/latest/userguide/access-bucket-intro.html\n    for more details.","ref":"FSS.S3.html#parse/2-options","title":"Options - FSS.S3.parse/2","type":"function"},{"doc":"Represents the configuration needed for accessing an S3 resource.","ref":"FSS.S3.Config.html","title":"FSS.S3.Config","type":"module"},{"doc":"The configuration struct for S3.\n\nThe attributes are:\n\n* `:access_key_id` - This attribute is required.\n\n* `:secret_access_key` - This attribute is required.\n\n* `:bucket` - A valid bucket name. This attribute is optional,\n  but if is not provided, then the `:endpoint` must include the bucket name\n  either in the host, as a virtual host, or in the path. In other words:\n  if the bucket is not given, then `:endpoint` must be configured.\n\n  This attribute is going to be set to `nil` if the endpoint was\n  not provided, unless the bucket name contain dots in it.\n\n* `:region` - This attribute is optional. It's normally required when working\n  with the official AWS S3 API.\n\n* `:endpoint` - If specified, then `:region` is ignored.\n  This attribute is required to be configured if you are using a service that\n  is compatible with the AWS S3 API.\n\n  In case only a \"bucket URL\" - without discrimination of the bucket name - is provided\n  then the `:bucket` attribute can be nil just like the `:region`.\n\n  In case the endpoint is not provided, we compute a valid one for the AWS S3 API.\n  This endpoint is going to follow the virtual-host style most of the time, with\n  the only exception being when the bucket name has dots. In that case we build\n  the AWS S3 endpoint without the bucket name in it.\n\n* `:token` - This attribute is optional.","ref":"FSS.S3.Config.html#t:t/0","title":"FSS.S3.Config.t/0","type":"type"},{"doc":"Represents the S3 resource itself.","ref":"FSS.S3.Entry.html","title":"FSS.S3.Entry","type":"module"},{"doc":"The entry struct for S3.\n\nThe attributes are:\n\n* `:key` - A valid key for the resource. This attribute is required.\n* `:config` - A valid S3 config from the type `Config.t()`. This attribute is required.","ref":"FSS.S3.Entry.html#t:t/0","title":"FSS.S3.Entry.t/0","type":"type"}]}